// minedetector.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "minedetector.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>

//#define D(s)		s
#define D(s)

#define ismaru(a)		((((a)==1)||((a)==3))?1:0)

#define MAX_LOADSTRING 100

#define ON			(-1)
#define OFF			(0)

static SHACTIVATEINFO s_sai;

// Global Variables:
HINSTANCE			g_hInst;				// The current instance
HWND				g_hwndCB;					// The command bar handle

HWND				g_hWnd;

RECT				tWinMain;
RECT				tWinGame;

HDC					hdcScreen = 0;
HBITMAP				hScreen;

#define MAX_X		11
#define MAX_Y		11
int					iBord[MAX_Y][MAX_X];	// Q[{[h
int					iKoma[MAX_Y][MAX_X];	// {[h̃R}
int					iEntr[MAX_Y][MAX_X];	// vC[̃Zbgl

#define LEVEL_1		3
#define LEVEL_2		4
#define LEVEL_3		5
int					iLevel = LEVEL_2;		// Q[x

static SHACTIVATEINFO s_st;

#define MODE_END	(0x00000001UL)
#define MODE_BOMB	(0x00000010UL)
#define MODE_MOVE	(0x00000020UL)
#define MODE_IGNORE	(0x10000000UL)
int					iMode = 0;

#define OPTION_EASY1	(0x00000001UL)
#define OPTION_EASY2	(0x00000002UL)
int					iOption = OPTION_EASY1;

////////

int iX, iY, iL;
int iXX, iYY;

int iCX, iCY;								// J[\

#if 0
void debug(void)
{
	TCHAR msg[(MAX_X+3)*(MAX_Y)];
	int x, y, z;

	z = 0;
	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			msg[z++] = (iBord[y][x])? _T('*'): _T('o');
		}
		msg[z++] = _T('\r');
		msg[z++] = _T('\n');
	}
	msg[z++] = 0;
	MessageBox(g_hWnd, msg, _T("debug"), MB_OK);
}
#endif

void SetEntryDefault(void)
{
	int x, y;

	if (iOption & OPTION_EASY1) {
		for (y=1; y<MAX_Y-1; y+=2) {
			for (x=1; x<MAX_X-1; x+=2) {
				iEntr[y][x] = 2;
			}
		}
	}
	if (iOption & OPTION_EASY2) {
		for (y=0; y<MAX_Y; y+=2) {
			for (x=0; x<MAX_X; x+=2) {
				iEntr[y][x] = 1;
			}
		}
	}
}

void SetEntryClear(void)
{
	int x, y;

	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			iEntr[y][x] = 0;
		}
	}
	SetEntryDefault();
}

void ClearMasu(void)
{
	int x, y;

	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			iEntr[y][x] = 0;
			iBord[y][x] = 1;
		}
	}
	SetEntryDefault();
}

int dig(int x, int y)
{
	static int s = 0;
	D(TCHAR msg[80]);
	int dir[5];
	int r, n;
	int nx, ny;
	int w;

	w = 0;
	if (y >= 2) {
		if (iBord[y-2][x] == 1) {
			dir[w++] = 0;
		}
	}
	if (x < MAX_X-2) {
		if (iBord[y][x+2] == 1) {
			dir[w++] = 1;
		}
	}
	if (y < MAX_Y-2) {
		if (iBord[y+2][x] == 1) {
			dir[w++] = 2;
		}
	}
	if (x >= 2) {
		if (iBord[y][x-2] == 1) {
			dir[w++] = 3;
		}
	}
	dir[w] = -1;

	if (w == 0) {
		D(debug());
		return (0);
	} else if (w > 1) {
		n = Random() % w;
	} else {
		n = 0;
	}
	r = dir[n];

	s++;

	switch (r) {
	case 0:
		iBord[y-1][x] = iBord[y-2][x] = 0;
		ny = y - 2;
		nx = x;
		break;
	case 1:
		iBord[y][x+1] = iBord[y][x+2] = 0;
		ny = y;
		nx = x + 2;
		break;
	case 2:
		iBord[y+1][x] = iBord[y+2][x] = 0;
		ny = y + 2;
		nx = x;
		break;
	case 3:
		iBord[y][x-1] = iBord[y][x-2] = 0;
		ny = y;
		nx = x - 2;
		break;
	}

	if (iL < s) {
		iL = s;
		iX = nx;
		iY = ny;
	}

	while (dig(nx, ny)) {;}
	s--;
	return (1);
}

void MakeWall(void)
{
	int x, y;

	iL = 0;

	x = y = 0;
	iBord[y][x] = 0;
	while (dig(x, y)) {;}
}
////////

// ͈̓`FbN
int CheckArea(int x1, int y1, int x2, int y2)
{
	int xx = (x1 > x2)? x1-x2: x2-x1;
	int yy = (y1 > y2)? y1-y2: y2-y1;

	if ((xx < iLevel) && (yy < iLevel)) {
		return -1;
	} else {
		return 0;
	}
}

// J[\̕\
void GmDispCsr(int x, int y, int sw)
{
	HBRUSH hBr, hOldBr;
	HPEN hPen, hOldPen;
	COLORREF c;
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;
	int boxx = tWinGame.left+x*d;
	int boxy = tWinGame.top +y*d;

	hBr = (HBRUSH)GetStockObject(NULL_BRUSH);
	hOldBr = (HBRUSH)SelectObject(hdcScreen, hBr);
	if (sw == ON) {
		if (iMode & MODE_MOVE) {
			c = RGB(100, 100, 255);
		} else {
			c = RGB(255, 0, 128);
		}
	} else {
		c = RGB(0, 0, 0);
	}
	hPen = CreatePen(PS_SOLID, 2, c);
	hOldPen = (HPEN)SelectObject(hdcScreen, hPen);
	Rectangle(hdcScreen, boxx, boxy, boxx+d, boxy+d);
	SelectObject(hdcScreen, hOldBr);
	SelectObject(hdcScreen, hOldPen);
	DeleteObject(hPen);
}

// }[N̕\
void GmDispMark(int x, int y, COLORREF c, TCHAR *pszItem)
{
	RECT rArea;
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;

	rArea.left   = tWinGame.left  +x*d + 1;
	rArea.top    = tWinGame.top   +y*d + 0;
	rArea.right  = tWinGame.left  +(x+1)*d + 1;
	rArea.bottom = tWinGame.top   +(y+1)*d + 0;

	SetBkMode(hdcScreen, TRANSPARENT);
	SetTextColor(hdcScreen, c);
	DrawText(hdcScreen, pszItem, -1, &rArea, DT_SINGLELINE | DT_VCENTER | DT_CENTER);
	SetTextColor(hdcScreen, RGB(0, 0, 0));
	SetBkMode(hdcScreen, OPAQUE);
}

// }X̏
void GmClearBox(int x, int y)
{
	RECT rArea;
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;

	rArea.left   = tWinGame.left  +x*d;
	rArea.top    = tWinGame.top   +y*d;
	rArea.right  = tWinGame.left  +(x+1)*d;
	rArea.bottom = tWinGame.top   +(y+1)*d;

	PatBlt( hdcScreen, 
			rArea.left + 1, 
			rArea.top  + 1, 
			rArea.right - rArea.left - 1, 
			rArea.bottom - rArea.top - 1, 
			WHITENESS );
}

// }X̕\]
void GmDispBoxInv(int x, int y)
{
	RECT rArea;
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;

	rArea.left   = tWinGame.left  +x*d;
	rArea.top    = tWinGame.top   +y*d;
	rArea.right  = tWinGame.left  +(x+1)*d;
	rArea.bottom = tWinGame.top   +(y+1)*d;

	PatBlt( hdcScreen, 
			rArea.left + 1, 
			rArea.top  + 1, 
			rArea.right - rArea.left - 1, 
			rArea.bottom - rArea.top - 1, 
			PATINVERT );
}

// }X̕\
void GmDispBoxNum(int x, int y, int num)
{
	RECT rArea;
	TCHAR szNum[8];
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;

	wsprintf(szNum, TEXT("%d"), num);

	rArea.left   = tWinGame.left  +x*d;
	rArea.top    = tWinGame.top   +y*d;
	rArea.right  = tWinGame.left  +(x+1)*d;
	rArea.bottom = tWinGame.top   +(y+1)*d;

//	PatBlt( hdcScreen, 
//			rArea.left + 1, 
//			rArea.top  + 1, 
//			rArea.right - rArea.left - 1, 
//			rArea.bottom - rArea.top - 1, 
//			WHITENESS );
	if (CheckArea(x, y, iX, iY)) {
		SetBkMode(hdcScreen, TRANSPARENT);
		DrawText(hdcScreen, szNum, -1, &rArea, 
				DT_SINGLELINE | DT_VCENTER | DT_CENTER);
		SetBkMode(hdcScreen, OPAQUE);
	}
}

// ~̕\
void GmDispCross(int x, int y)
{
	POINT ptArray[2];
	HBRUSH hBr, hOldBr;
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;
	int boxx = tWinGame.left+x*d;
	int boxy = tWinGame.top +y*d;

	switch (iEntr[y][x]) {
	case 1:
		hBr = (HBRUSH)GetStockObject(NULL_BRUSH);
		hOldBr = (HBRUSH)SelectObject(hdcScreen, hBr);
		Ellipse(hdcScreen, boxx+2, boxy+2, boxx+d-1, boxy+d-1);
		SelectObject(hdcScreen, hOldBr);
		break;
	case 2:
		ptArray[0].x = boxx+2;
		ptArray[0].y = boxy+2;
		ptArray[1].x = boxx+d-2;
		ptArray[1].y = boxy+d-2;
		Polygon(hdcScreen, ptArray, 2);
		ptArray[0].x = boxx+d-2;
		ptArray[1].x = boxx+2;
		Polygon(hdcScreen, ptArray, 2);
		break;
	case 3:
		hBr = (HBRUSH)GetStockObject(NULL_BRUSH);
		hOldBr = (HBRUSH)SelectObject(hdcScreen, hBr);
		Ellipse(hdcScreen, boxx+2, boxy+2, boxx+d/2-1, boxy+d/2-1);
		SelectObject(hdcScreen, hOldBr);
		break;
	case 4:
		ptArray[0].x = boxx+2;
		ptArray[0].y = boxy+2;
		ptArray[1].x = boxx+d/2-2;
		ptArray[1].y = boxy+d/2-2;
		Polygon(hdcScreen, ptArray, 2);
		ptArray[0].x = boxx+d/2-2;
		ptArray[1].x = boxx+2;
		Polygon(hdcScreen, ptArray, 2);
		break;
	default:
		break;
	}
}

// }Xڂ̓e\
void GmDispItem(int x, int y)
{
	GmDispCross(x, y);
	if ((x == iX) && (y == iY)) {
		GmDispMark(iX, iY, RGB(0, 255, 255), _T(""));
	} else if ((x == 0) && (y == 0)) {
		GmDispMark(0, 0, RGB(128, 255, 128), _T(""));
	}
	GmDispBoxNum(x, y, iKoma[y][x]);
}

// 쐬
int GmMakeKoma(int koma[MAX_Y][MAX_X], int bord[MAX_Y][MAX_X])
{
	int x, y;
	int n;

	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			n = 0;
			if  (y > 0)							n += ismaru(bord[y-1][x  ]);	// 
			if  (x > 0)							n += ismaru(bord[y  ][x-1]);	// 
			if  (y < MAX_Y-1)					n += ismaru(bord[y+1][x  ]);	// 
			if  (x < MAX_X-1)					n += ismaru(bord[y  ][x+1]);	// E
			if ((y > 0)       && (x > 0))		n += ismaru(bord[y-1][x-1]);	// 
			if ((y > 0)       && (x < MAX_X-1))	n += ismaru(bord[y-1][x+1]);	// E
			if ((y < MAX_Y-1) && (x > 0))		n += ismaru(bord[y+1][x-1]);	// 
			if ((y < MAX_Y-1) && (x < MAX_X-1))	n += ismaru(bord[y+1][x+1]);	// E
			koma[y][x] = n;
		}
	}
	return 0;
}

// 쐬
int GmNewGame(void)
{
#if 1
	iMode = MODE_IGNORE;
	ClearMasu();
	MakeWall();
	iXX = iCX = iX;
	iYY = iCY = iY;
	return GmMakeKoma(iKoma, iBord);
#else
	int x, y;
	int cnt = 0;
	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			iBord[y][x] = (cnt < iLevel)? 1: 0;
			iEntr[y][x] = 0;
			cnt++;
		}
	}
	int r;
	int tmp;
	for (cnt=0;cnt<MAX_Y*MAX_X; cnt++) {
		r = Random() % (MAX_Y*MAX_X);
		tmp = iBord[cnt/MAX_Y][cnt%MAX_Y];
		iBord[cnt/MAX_Y][cnt%MAX_Y] = iBord[r/MAX_Y][r%MAX_Y];
		iBord[r/MAX_Y][r%MAX_Y] = tmp;
	}
	return GmMakeKoma(iKoma, iBord);
#endif
}

// {[h쐬
int GmDispBord(void)
{
	POINT ptArray[2];
	int x, y;

	PatBlt(hdcScreen, tWinGame.left, tWinGame.top, 
		tWinGame.right - tWinGame.left, 
		tWinGame.bottom - tWinGame.top, 
		WHITENESS);

	int d = (tWinGame.bottom - tWinGame.top) / MAX_Y;

	HPEN hPen = CreatePen(PS_SOLID, 2, RGB(0, 0, 0));
	HPEN hOldPen = (HPEN)SelectObject(hdcScreen, hPen);

	for (y=0; y<=MAX_Y; y++) {
		ptArray[0].y = ptArray[1].y = tWinGame.top+y*d;
		ptArray[0].x = tWinGame.left;
		ptArray[1].x = tWinGame.right;
		Polygon(hdcScreen, ptArray, 2);
		ptArray[0].x = ptArray[1].x = tWinGame.left+y*d;
		ptArray[0].y = tWinGame.top;
		ptArray[1].y = tWinGame.bottom;
		Polygon(hdcScreen, ptArray, 2);
	}

	SelectObject(hdcScreen, hOldPen);
	DeleteObject(hPen);

	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			GmDispItem(x, y);
		}
	}

	GmDispCsr(iCX, iCY, ON);
	return 0;
}

// \
BOOL GmCheckAnswer()
{
	int x, y;

	for (y=0; y<MAX_Y; y++) {
		for (x=0; x<MAX_X; x++) {
			if (iBord[y][x]) {
				GmDispBoxInv(x, y);
			}
		}
	}
	iMode |= MODE_END;
	return FALSE;
}

// 蒼
int GmRefreshBord(HWND hWnd)
{
	int res = MessageBox(hWnd, TEXT("ŏn߂܂H"), TEXT("mF"), MB_YESNO);
	if (res == IDYES) {
		iMode = MODE_IGNORE;
		SetEntryClear();
		iX = iCX = iXX;
		iY = iCY = iYY;
		GmDispBord();
		InvalidateRect(hWnd, &tWinMain, false);
	}

	return 0;
}

// V
void GmNextGame(HWND hWnd, int lev)
{
	int res = MessageBox(hWnd, TEXT("Vɂ܂H"), TEXT("mF"), MB_YESNO);
	if (res == IDYES) {
		if (lev) {
			iLevel = lev;

			switch (iLevel) {
			case LEVEL_1:
				iOption = 0;
				break;
			case LEVEL_2:
				iOption = OPTION_EASY1;
				break;
			case LEVEL_3:
			default:
				iOption = OPTION_EASY1 | OPTION_EASY2;
				break;
			}
		}
		GmNewGame();
		GmDispBord();
		InvalidateRect(hWnd, &tWinMain, false);
	}
}

// IvVݒ
#if 0
void GmOptionGame(HWND hWnd, int id)
{
	TCHAR msg[80];
	int opt;

	if (id == IDM_OPTION_GAME1) {
		lstrcpy(msg, TEXT("񂽂񃂁[h1"));
		opt = OPTION_EASY1;
	} else {
		lstrcpy(msg, TEXT("񂽂񃂁[h2"));
		opt = OPTION_EASY2;
	}
	if (iOption & opt) {
		lstrcat(msg, TEXT("܂H\r\n(񂩂L)"));
	} else {
		lstrcat(msg, TEXT("ݒ肵܂H\r\n(񂩂L)"));
	}
	int res = MessageBox(hWnd, msg, TEXT("mF"), MB_YESNO);
	if (res == IDYES) {
		iOption ^= opt;
	}
}
#endif

// ړ
int GmMove(HWND hWnd, int x, int y)
{
	GmDispBord();
	InvalidateRect(hWnd, NULL, FALSE);

	if (iBord[iY][iX]) {
		iMode |= MODE_BOMB;
		SetTimer(hWnd, 1, 250, NULL);
	}
	if ((iX == 0) && (iY == 0)) {
		iMode |= MODE_END;
		MessageBox(hWnd, TEXT("߂łƂ܂"), TEXT("NA"), MB_OK);
	}
	return 0;
}

// }[LO
void GmSetMark(HWND hWnd, int x, int y)
{
	iEntr[y][x]++;
	if (iEntr[y][x] > 4) {
		iEntr[y][x] = 0;
	}
	GmClearBox(x, y);
	GmDispItem(x, y);
	GmDispCsr(iCX, iCY, ON);
	InvalidateRect(hWnd, &tWinMain, false);
}

// ^bv
int GmTapPoint(HWND hWnd, int tapx, int tapy)
{
	if (iMode & MODE_IGNORE) {
		iMode &= ~MODE_IGNORE;
	}

	if (iMode & MODE_END) {
		GmNextGame(hWnd, 0);
		return 0;
	}
	if (iMode & MODE_BOMB) return 0;

	if ((tapx < tWinGame.left)  || 
		(tapx > tWinGame.right) ||
		(tapy < tWinGame.top)   ||
		(tapy > tWinGame.bottom)) {
		return 0;
	}

	GmDispCsr(iCX, iCY, OFF);
	int d = (tWinGame.bottom - tWinGame.top) / MAX_X;
	iCX = (tapx - tWinGame.left) / d;
	iCY = (tapy - tWinGame.top) / d;

	if ((iCX == iX) && (iCY == iY)) {
		iMode ^= MODE_MOVE;
	} else if (iMode & MODE_MOVE) {
		int dx = (iCX > iX)? iCX-iX: iX-iCX;
		int dy = (iCY > iY)? iCY-iY: iY-iCY;
		if (((dx == 1) && (dy == 0)) || ((dx == 0) && (dy == 1))) {
			iX = iCX;
			iY = iCY;
			return GmMove(hWnd, iX, iY);
		} else {
			iMode &= ~MODE_MOVE;
			GmSetMark(hWnd, iCX, iCY);
		}
	} else {
		GmSetMark(hWnd, iCX, iCY);
	}
	GmDispCsr(iCX, iCY, ON);
	InvalidateRect(hWnd, &tWinMain, false);
	return 0;
}

// WM_KEYUP
LRESULT DoKeyUp(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
	if (iMode & MODE_IGNORE) {
		iMode &= ~MODE_IGNORE;
		return 0;

	} else if (iMode & MODE_END) {
		switch (wParam) {
		case VK_UP:
		case VK_DOWN:
		case VK_LEFT:
		case VK_RIGHT:
			GmNextGame(hWnd, 0);
			break;
		default:
			break;
		}
		return 0;

	} else if (iMode & MODE_BOMB) {
		return 0;

	} else if (iMode & MODE_MOVE) {
		switch (wParam) {
		case VK_UP:
			if (iY > 0) 		iY--;
			break;
		case VK_DOWN:
			if (iY < MAX_Y-1) 	iY++;
			break;
		case VK_LEFT:
			if (iX > 0) 		iX--;
			break;
		case VK_RIGHT:
			if (iX < MAX_X-1) 	iX++;
			break;
		case VK_ESCAPE:
			iMode &= ~MODE_MOVE;
			GmDispBoxInv(iX, iY);
			InvalidateRect(hWnd, &tWinMain, false);
			break;
		case VK_RETURN:
			iMode &= ~MODE_MOVE;
			GmDispBoxInv(iX, iY);
			InvalidateRect(hWnd, &tWinMain, false);
			break;
		default:
			break;
		}

		iCX = iX;
		iCY = iY;
		return GmMove(hWnd, iX, iY);
	}

	GmDispCsr(iCX, iCY, OFF);

	switch (wParam) {
	case VK_UP:
		if (iCY > 0) 		iCY--;
		break;
	case VK_DOWN:
		if (iCY < MAX_Y-1) 	iCY++;
		break;
	case VK_LEFT:
		if (iCX > 0) 		iCX--;
		break;
	case VK_RIGHT:
		if (iCX < MAX_X-1) 	iCX++;
		break;
	case VK_RETURN:
		if ((iCX == iX) && (iCY == iY)) {
			iMode |= MODE_MOVE;
		} else {
			GmSetMark(hWnd, iCX, iCY);
			return 0;
		}
		break;
	default:
		break;
	}

	GmDispCsr(iCX, iCY, ON);
	InvalidateRect(hWnd, &tWinMain, false);
	return 0;
}

// WM_TIMER
LRESULT DoTimer(HWND hWnd)
{
	static int iTime = 0;

	iTime++;

	if (iTime & 1) {
		GmDispMark(iX, iY, RGB(255, 255, 0), _T(""));
		if (iTime > 10) {
			iTime = 0;
			iMode &= ~MODE_BOMB;
			KillTimer(hWnd, 1);
			GmDispBoxNum(iX, iY, iKoma[iY][iX]);
			GmCheckAnswer();
		}
	} else {
		GmDispMark(iX, iY, RGB(255, 128, 255), _T(""));
	}
	InvalidateRect(hWnd, NULL, FALSE);
	return 0;
}

// WM_CREATE
LRESULT DoCreate(HWND hWnd)
{
	// X[ACR̓o^
	HICON hIcon = (HICON)SendMessage(hWnd, WM_GETICON, 0, 0);
	if (hIcon == 0) {
		hIcon = (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(IDI_MINEDETECTOR), IMAGE_ICON, 16, 16, 0);
		SendMessage(hWnd, WM_SETICON, FALSE, (LPARAM)hIcon);
	}

	// EChE̎擾
	//RECT rt;
	//GetWindowRect(hWnd, &rt);
	//DoSize(hWnd, rt.right | rt.bottom<<16);

	g_hWnd = hWnd;

	iLevel = LEVEL_2;
	GmNewGame();

	return 0;
}

// WM_SIZE
LRESULT DoSize(HWND hWnd, LPARAM lParam)
{
	int cbh = CommandBar_Height(g_hwndCB);

	// CEChE
	tWinMain.left   = 0;
	tWinMain.top    = 0;
	tWinMain.right  = LOWORD(lParam);
	tWinMain.bottom = HIWORD(lParam);

	// Q[{[h
	int tmp;
	int w = tWinMain.right;
	int h = tWinMain.bottom;

	if (h > w) {
		tmp = w / MAX_X;
		tmp *= MAX_X;
	} else {
		tmp = h / MAX_Y;
		tmp *= MAX_Y;
	}
	tWinGame.left = (w - tmp) / 2;
	tWinGame.top  = (h - tmp) / 2;

	tWinGame.right  = tWinGame.left + tmp;
	tWinGame.bottom = tWinGame.top + tmp;

	// EChEݒ
	//MoveWindow( hWnd, 
	//			tWinMain.left,
	//			tWinMain.top,
	//			tWinMain.right,
	//			tWinMain.bottom,
	//			TRUE );

	if (hdcScreen) {
		DeleteObject(hScreen);
		DeleteDC(hdcScreen);
	}

	hdcScreen = CreateCompatibleDC(GetDC(hWnd));
	hScreen = CreateCompatibleBitmap(GetDC(hWnd), tWinMain.right, tWinMain.bottom);
	SelectObject(hdcScreen, hScreen);

	HBRUSH hbrOld = (HBRUSH)SelectObject(hdcScreen, GetStockObject(LTGRAY_BRUSH));
	Rectangle(hdcScreen, tWinMain.left, tWinMain.top, 
						tWinMain.right, tWinMain.bottom);
	SelectObject(hdcScreen, hbrOld);

#if 0
	{
		TCHAR str[256];
		wsprintf(str, TEXT("%d %d %d %d / %d %d %d %d"),
						tWinMain.left,
						tWinMain.top,
						tWinMain.right,
						tWinMain.bottom,
						tWinGame.left,
						tWinGame.top,
						tWinGame.right,
						tWinGame.bottom);
		MessageBox(hWnd, str, TEXT("debug"), MB_OK);
	}
#endif

	return 0;
}

// WM_PAINT
LRESULT DoPaint(HWND hWnd)
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rt;

	hdc = BeginPaint(hWnd, &ps);
	GetClientRect(hWnd, &rt);
	BitBlt(hdc, 0, 0, tWinMain.right, tWinMain.bottom, 
			hdcScreen, 0, 0, SRCCOPY);
	EndPaint(hWnd, &ps);

	return 0;
}

// WM_DESTROY
LRESULT DoDestroy(HWND hWnd)
{
	DeleteObject(hScreen);
	DeleteDC(hdcScreen);
	return 0;
}

////////
// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_MINEDETECTOR);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_MINEDETECTOR));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	g_hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_MINEDETECTOR, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		// set focus to foremost child window
		// The "| 0x01" is used to bring any owned windows to the foreground and
		// activate them.
		SetForegroundWindow((HWND)((ULONG) hWnd | 0x00000001));
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	if (g_hwndCB)
    {
		RECT rc;
        RECT rcMenuBar;

		GetWindowRect(hWnd, &rc);
        GetWindowRect(g_hwndCB, &rcMenuBar);
		rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
		
		MoveWindow(hWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
	}


	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static LPARAM flag = 0;
	int wmId, wmEvent;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{	
				case IDM_HELP_ABOUT:
					DialogBox(g_hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				    break;
				case IDOK:
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;
				case IDM_FILE_EXIT:
					DestroyWindow(hWnd);
					break;
				case IDM_GAME_NEW_1:
					GmNextGame(hWnd, LEVEL_1);
					break;
				case IDM_GAME_NEW_2:
					GmNextGame(hWnd, LEVEL_2);
					break;
				case IDM_GAME_NEW_3:
					GmNextGame(hWnd, LEVEL_3);
					break;
				case IDM_GAME_CLEAR:
					GmRefreshBord(hWnd);
					break;
				//case IDM_OPTION_GAME1:
				//case IDM_OPTION_GAME2:
				//	GmOptionGame(hWnd, wmId);
				//	break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			g_hwndCB = CreateRpCommandBar(hWnd);
            // Initialize the shell activate info structure
            memset (&s_st, 0, sizeof (s_st));
            s_st.cbSize = sizeof (s_st);
			DoCreate(hWnd);
			break;
		case WM_SIZE:
			if (flag != lParam) {
				flag = lParam;
				DoSize(hWnd, lParam);
				GmDispBord();
			}
			break; 
		case WM_PAINT:
			DoPaint(hWnd);
			break;
		case WM_LBUTTONDOWN:
			GmTapPoint(hWnd, LOWORD(lParam), HIWORD(lParam));
			break;
		case WM_KEYUP:
			DoKeyUp(hWnd, wParam, lParam);
			break;
		case WM_TIMER:
			DoTimer(hWnd);
			break;
		case WM_DESTROY:
			DoDestroy(hWnd);
			CommandBar_Destroy(g_hwndCB);
			PostQuitMessage(0);
			break;
		case WM_ACTIVATE:
            // Notify shell of our activate message
			SHHandleWMActivate(hWnd, wParam, lParam, &s_st, FALSE);
     		break;
		case WM_SETTINGCHANGE:
			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_st);
     		break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = g_hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
